'\"
'\" Generated from file 'smtp\&.man' by tcllib/doctools with format 'nroff'
'\" Copyright (c) 1999-2000 Marshall T\&. Rose and others
'\"
.TH "smtp" n 1\&.4\&.5 tcllib "smtp client"
.\" The -*- nroff -*- definitions below are for supplemental macros used
.\" in Tcl/Tk manual entries.
.\"
.\" .AP type name in/out ?indent?
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS ?type? ?name?
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .CS
.\"	Begin code excerpt.
.\"
.\" .CE
.\"	End code excerpt.
.\"
.\" .VS ?version? ?br?
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.  The first argument is ignored and used for recording
.\"	the version when the .VS was added, so that the sidebars can be
.\"	found and removed when they reach a certain age.  If another argument
.\"	is present, then a line break is forced before starting the sidebar.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
.\" .SO ?manpage?
.\"	Start of list of standard options for a Tk widget. The manpage
.\"	argument defines where to look up the standard options; if
.\"	omitted, defaults to "options". The options follow on successive
.\"	lines, in three columns separated by tabs.
.\"
.\" .SE
.\"	End of list of standard options for a Tk widget.
.\"
.\" .OP cmdName dbName dbClass
.\"	Start of description of a specific option.  cmdName gives the
.\"	option's name as specified in the class command, dbName gives
.\"	the option's name in the option database, and dbClass gives
.\"	the option's class in the option database.
.\"
.\" .UL arg1 arg2
.\"	Print arg1 underlined, then print arg2 normally.
.\"
.\" .QW arg1 ?arg2?
.\"	Print arg1 in quotes, then arg2 normally (for trailing punctuation).
.\"
.\" .PQ arg1 ?arg2?
.\"	Print an open parenthesis, arg1 in quotes, then arg2 normally
.\"	(for trailing punctuation) and then a closing parenthesis.
.\"
.\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
.\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1 \\fI\\$2\\fP (\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
.\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
.\"	# BS - start boxed text
.\"	# ^y = starting y location
.\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
.\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
.\"	# VS - start vertical sidebar
.\"	# ^Y = starting y location
.\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
.\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
.\"	# Special macro to handle page bottom:  finish off current
.\"	# box/sidebar if in box/sidebar mode, then invoked standard
.\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
.\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
.\"	# DE - end display
.de DE
.fi
.RE
.sp
..
.\"	# SO - start of list of standard options
.de SO
'ie '\\$1'' .ds So \\fBoptions\\fR
'el .ds So \\fB\\$1\\fR
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 5.5c 11c
.ft B
..
.\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\*(So manual entry for details on the standard options.
..
.\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
.\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
.\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.\"	# UL - underline word
.de UL
\\$1\l'|0\(ul'\\$2
..
.\"	# QW - apply quotation marks to word
.de QW
.ie '\\*(lq'"' ``\\$1''\\$2
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\$2
..
.\"	# PQ - apply parens and quotation marks to word
.de PQ
.ie '\\*(lq'"' (``\\$1''\\$2)\\$3
.\"" fix emacs highlighting
.el (\\*(lq\\$1\\*(rq\\$2)\\$3
..
.\"	# QR - quoted range
.de QR
.ie '\\*(lq'"' ``\\$1''\\-``\\$2''\\$3
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\-\\*(lq\\$2\\*(rq\\$3
..
.\"	# MT - "empty" string
.de MT
.QW ""
..
.BS
.SH NAME
smtp \- Client-side tcl implementation of the smtp protocol
.SH SYNOPSIS
package require \fBTcl \fR
.sp
package require \fBmime  ?1\&.5\&.4?\fR
.sp
package require \fBsmtp  ?1\&.4\&.5?\fR
.sp
\fB::smtp::sendmessage\fR \fItoken\fR \fIoption\fR\&.\&.\&.
.sp
.BE
.SH DESCRIPTION
.PP
The \fBsmtp\fR library package provides the client side of the
Simple Mail Transfer Protocol (SMTP) (1) (2)\&.
.TP
\fB::smtp::sendmessage\fR \fItoken\fR \fIoption\fR\&.\&.\&.
This command sends the MIME part (see package \fBmime\fR)
represented by \fItoken\fR to an SMTP server\&. \fIoptions\fR is a list
of options and their associated values\&.  The recognized options are:
.RS
.TP
\fB-servers\fR
A list of SMTP servers\&. The default is \fBlocalhost\fR\&.
.TP
\fB-ports\fR
A list of SMTP ports\&. The default is \fB25\fR\&.
.TP
\fB-client\fR
The name to use as our hostname when connecting to the server\&. By
default this is either localhost if one of the servers is localhost,
or is set to the string returned by \fBinfo hostname\fR\&.
.TP
\fB-queue\fR
Indicates that the SMTP server should be asked to queue the message
for later processing\&. A boolean value\&.
.TP
\fB-atleastone\fR
Indicates that the SMTP server must find at least one recipient
acceptable for the message to be sent\&. A boolean value\&.
.TP
\fB-originator\fR
A string containing an 822-style address specification\&. If present the
header isn't examined for an originator address\&.
.TP
\fB-recipients\fR
A string containing one or more 822-style address specifications\&. If
present the header isn't examined for recipient addresses)\&. If the
string contains more than one address they will be separated by
commas\&.
.TP
\fB-header\fR
A list containing two elements, an smtp header and its associated
value (the -header option may occur zero or more times)\&.
.TP
\fB-usetls\fR
This package supports the RFC 3207 TLS extension (3) by default provided the
tls package is available\&. You can turn this off with this boolean option\&.
.TP
\fB-tlspolicy\fR
This option lets you specify a command to be called if an error occurs
during TLS setup\&. The command is called with the SMTP code and diagnostic
message appended\&. The command should return 'secure' or 'insecure' where
insecure will cause the package to continue on the unencrypted channel\&.
Returning 'secure' will cause the socket to be closed and the next server
in the \fB-servers\fR list to be tried\&.
.TP
\fB-username\fR
.TP
\fB-password\fR
If your SMTP server requires authentication (RFC 2554 (4)) before
accepting mail you can use \fB-username\fR and \fB-password\fR
to provide your authentication details to the server\&. Currently this
package supports DIGEST-MD5, CRAM-MD5, LOGIN and PLAIN authentication
methods\&. The most secure method will be tried first and each method
tried in turn until we are either authorized or we run out of
methods\&. Note that if the server permits a TLS connection, then the
authorization will occur after we begin using the secure channel\&.
.sp
Please also read the section on \fBAuthentication\fR, it details
the necessary prequisites, i\&.e\&. packages needed to support these
options and authentication\&.
.RE
.sp
If the \fB-originator\fR option is not present, the originator
address is taken from \fBFrom\fR (or \fBResent-From\fR);
similarly, if the \fB-recipients\fR option is not present,
recipient addresses are taken from \fBTo\fR, \fBcc\fR, and
\fBBcc\fR (or \fBResent-To\fR, and so on)\&. Note that the header
key/values supplied by the \fB-header\fR option (not those present
in the MIME part) are consulted\&. Regardless, header key/values are
added to the outgoing message as necessary to ensure that a valid
822-style message is sent\&.
.sp
The command returns a list indicating which recipients were
unacceptable to the SMTP server\&. Each element of the list is another
list, containing the address, an SMTP error code, and a textual
diagnostic\&. Depending on the \fB-atleastone\fR option and the
intended recipients, a non-empty list may still indicate that the
message was accepted by the server\&.
.PP
.SH AUTHENTICATION
Beware\&. SMTP authentication uses \fBSASL\fR\&. I\&.e\&. if the user
has to authenticate a connection, i\&.e\&. use the options \fB-user\fR
and \fB-password\fR (see above) it is necessary to have the
\fBsasl\fR package available so that \fBsmtp\fR can load it\&.
.PP
This is a soft dependency because not everybody requires authentication,
and \fBsasl\fR depends on a lot of the cryptographic (secure) hashes,
i\&.e\&. all of \fBmd5\fR, \fBotp\fR, \fBmd4\fR, \fBsha1\fR,
and \fBripemd160\fR\&.
.SH EXAMPLE
.CS


proc send_simple_message {recipient email_server subject body} {
    package require smtp
    package require mime

    set token [mime::initialize -canonical text/plain \\\\
	-string $body]
    mime::setheader $token Subject $subject
    smtp::sendmessage $token \\\\
	-recipients $recipient -servers $email_server
    mime::finalize $token
}

send_simple_message someone@somewhere\&.com localhost \\\\
    "This is the subject\&." "This is the message\&."

.CE
.SH "TLS SECURITY CONSIDERATIONS"
This package uses the \fBTLS\fR package to handle the security
for \fBhttps\fR urls and other socket connections\&.
.PP
Policy decisions like the set of protocols to support and what
ciphers to use are not the responsibility of \fBTLS\fR, nor of
this package itself however\&.
Such decisions are the responsibility of whichever application is
using the package, and are likely influenced by the set of servers
the application will talk to as well\&.
.PP
For example, in light of the recent
\fIPOODLE attack\fR [http://googleonlinesecurity\&.blogspot\&.co\&.uk/2014/10/this-poodle-bites-exploiting-ssl-30\&.html] discovered by Google many servers will disable support
for the SSLv3 protocol\&.
To handle this change the applications using \fBTLS\fR must be
patched, and not this package, nor \fBTLS\fR itself\&.
Such a patch may be as simple as generally activating \fBtls1\fR
support, as shown in the example below\&.
.CS


    package require tls
    tls::init -tls1 1 ;# forcibly activate support for the TLS1 protocol

    \&.\&.\&. your own application code \&.\&.\&.

.CE
.SH REFERENCES
.IP [1]
Jonathan B\&. Postel, "SIMPLE MAIL TRANSFER PROTOCOL", RFC 821, August 1982\&.
(\fIhttp://www\&.rfc-editor\&.org/rfc/rfc821\&.txt\fR)
.IP [2]
J\&. Klensin, "Simple Mail Transfer Protocol", RFC 2821, April 2001\&.
(\fIhttp://www\&.rfc-editor\&.org/rfc/rfc2821\&.txt\fR)
.IP [3]
P\&. Hoffman, "SMTP Service Extension for Secure SMTP over Transport
Layer Security", RFC 3207, February 2002\&.
(\fIhttp://www\&.rfc-editor\&.org/rfc/rfc3207\&.txt\fR)
.IP [4]
J\&. Myers, "SMTP Service Extension for Authentication",
RFC 2554, March 1999\&.
(\fIhttp://www\&.rfc-editor\&.org/rfc/rfc2554\&.txt\fR)
.PP
.SH "BUGS, IDEAS, FEEDBACK"
This document, and the package it describes, will undoubtedly contain
bugs and other problems\&.
Please report such in the category \fIsmtp\fR of the
\fITcllib Trackers\fR [http://core\&.tcl\&.tk/tcllib/reportlist]\&.
Please also report any ideas for enhancements you may have for either
package and/or documentation\&.
.SH "SEE ALSO"
ftp, http, mime, pop3
.SH KEYWORDS
email, internet, mail, mime, net, rfc 2554, rfc 2821, rfc 3207, rfc 821, rfc 822, smtp, tls
.SH CATEGORY
Networking
.SH COPYRIGHT
.nf
Copyright (c) 1999-2000 Marshall T\&. Rose and others

.fi